(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/dialog'), require('@ngx-translate/core'), require('@angular/forms'), require('rxjs/operators'), require('@angular/material/form-field'), require('@angular/material/tooltip'), require('@angular/common'), require('rxjs'), require('@angular/material/icon')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-base-angular-comp', ['exports', '@angular/core', '@angular/material/dialog', '@ngx-translate/core', '@angular/forms', 'rxjs/operators', '@angular/material/form-field', '@angular/material/tooltip', '@angular/common', 'rxjs', '@angular/material/icon'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-base-angular-comp'] = {}), global.ng.core, global.ng.material.dialog, global['@ngx-translate/core'], global.ng.forms, global.rxjs.operators, global.ng.material['form-field'], global.ng.material.tooltip, global.ng.common, global.rxjs, global.ng.material.icon));
}(this, (function (exports, core, dialog, core$1, forms, operators, formField, tooltip, common, rxjs, icon) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ErrorDialog = /** @class */ (function () {
        function ErrorDialog(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        /**
         * @return {?}
         */
        ErrorDialog.prototype.onNoClick = /**
         * @return {?}
         */
        function () {
            this.dialogRef.close();
        };
        /**
         * @param {?} e
         * @param {?=} data
         * @return {?}
         */
        ErrorDialog.extractErrorInfo = /**
         * @param {?} e
         * @param {?=} data
         * @return {?}
         */
        function (e, data) {
            if (data === void 0) { data = {}; }
            return Object.assign(data, {
                showDetails: core.isDevMode(),
                message: e.message
            });
        };
        /**
         * show error popup if needed
         * @param dialog dialog factory
         * @param e error
         * @param opts
         */
        /**
         * show error popup if needed
         * @param {?} dialog dialog factory
         * @param {?} e error
         * @param {?=} opts
         * @return {?}
         */
        ErrorDialog.openErrorDialog = /**
         * show error popup if needed
         * @param {?} dialog dialog factory
         * @param {?} e error
         * @param {?=} opts
         * @return {?}
         */
        function (dialog, e, opts) {
            if (opts === void 0) { opts = {}; }
            /** @type {?} */
            var config = Object.assign({
                canBeClosed: true,
                closeOnNavigation: true,
                panelClass: 'dialog-layout',
                disableClose: false,
            }, opts);
            config.data = ErrorDialog.extractErrorInfo(e, config.data);
            console.log('openErrorDialog: ', config);
            /** @type {?} */
            var dialogRef = dialog.open(ErrorDialog, config);
            dialogRef.disableClose = false;
            dialogRef.afterClosed().subscribe((/**
             * @param {?} result
             * @return {?}
             */
            function (result) {
                console.log('The dialog was closed', result);
            }));
            console.log(e);
            return dialogRef;
        };
        ErrorDialog.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-error-dialog',
                        template: "<h2>ERROR</h2>\n<p>{{data.message}}</p>\n<mat-dialog-content>\n\n  <div class=\"error-info\">\n    <table class=\"info-grid\">\n      <tbody>\n      <tr *ngIf=\"data.status\"><td class=\"label\">Status</td><td class=\"val\">{{data.status}}</td></tr>\n      <tr *ngIf=\"data.code\"><td class=\"label\">Code</td><td class=\"val\">{{data.code}}</td></tr>\n      <tr *ngIf=\"data.link\"><td class=\"label\">Link</td><td class=\"val\">{{data.link}}</td></tr>\n      <tr *ngIf=\"data.request\"><td class=\"label\">Request</td><td class=\"val\">{{data.request}}</td></tr>\n      <tr *ngIf=\"data.operation\"><td class=\"label\">Operation</td><td class=\"val\">{{data.operation}}</td></tr>\n      <tr *ngIf=\"data.component\"><td class=\"label\">Component</td><td class=\"val\">{{data.component}}</td></tr>\n      <tr *ngIf=\"data.developerMessage\"><td class=\"label\">Dev Message:</td><td class=\"val\">{{data.developerMessage}}</td></tr>\n      </tbody>\n    </table>\n  </div>\n\n</mat-dialog-content>\n\n<mat-dialog-actions>\n    <button type=\"button\" class=\"cmd\" matDialogClose mat-raised-button color=\"primary\">Close</button>\n</mat-dialog-actions>\n"
                    }] }
        ];
        /** @nocollapse */
        ErrorDialog.ctorParameters = function () { return [
            { type: dialog.MatDialogRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
        ]; };
        return ErrorDialog;
    }());
    if (false) {
        /** @type {?} */
        ErrorDialog.prototype.dialogRef;
        /** @type {?} */
        ErrorDialog.prototype.data;
    }
    var ErrorDialogHandler = /** @class */ (function () {
        function ErrorDialogHandler(dialog) {
            this.dialog = dialog;
        }
        /**
         * @param {?} error
         * @return {?}
         */
        ErrorDialogHandler.prototype.handleError = /**
         * @param {?} error
         * @return {?}
         */
        function (error) {
            console.warn("ErrorDialogHandler handleError:", error);
            ErrorDialog.openErrorDialog(this.dialog, error);
        };
        return ErrorDialogHandler;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ErrorDialogHandler.prototype.dialog;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BaseDateComponent = /** @class */ (function () {
        function BaseDateComponent(translate) {
            this.translate = translate;
            this.format = 'day';
            this.formatTip = 'date';
        }
        /**
         * @return {?}
         */
        BaseDateComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (this.translate != null) {
                this.format = this.translatePattern(this.format, 'yyyy-MM-dd');
                if ('false' !== this.formatTip) {
                    this.formatTip = this.translatePattern(this.formatTip, 'yyyy-MM-dd HH:mm:ss Z');
                }
            }
        };
        /**
         * @param {?} key
         * @param {?} fallback
         * @return {?}
         */
        BaseDateComponent.prototype.translatePattern = /**
         * @param {?} key
         * @param {?} fallback
         * @return {?}
         */
        function (key, fallback) {
            /** @type {?} */
            var value = fallback;
            if (BaseDateComponent.FORMAT_NAMES.indexOf(key) !== -1) {
                this.translate.get(BaseDateComponent.RES_PREFIX + key).subscribe((/**
                 * @param {?} result
                 * @return {?}
                 */
                function (result) {
                    value = result;
                }));
            }
            return value;
        };
        BaseDateComponent.RES_PREFIX = 'DateFormat.';
        BaseDateComponent.FORMAT_NAMES = ['day', 'date', 'full', 'time', 'year'];
        BaseDateComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-date',
                        template: "<span *ngIf=\"data\"\n      [matTooltip]=\"formatTip != 'false' ? (data|date:formatTip) : null\">{{data|date:format}}</span>\n"
                    }] }
        ];
        /** @nocollapse */
        BaseDateComponent.ctorParameters = function () { return [
            { type: core$1.TranslateService }
        ]; };
        BaseDateComponent.propDecorators = {
            data: [{ type: core.Input }],
            format: [{ type: core.Input }],
            formatTip: [{ type: core.Input }]
        };
        return BaseDateComponent;
    }());
    if (false) {
        /** @type {?} */
        BaseDateComponent.RES_PREFIX;
        /** @type {?} */
        BaseDateComponent.FORMAT_NAMES;
        /** @type {?} */
        BaseDateComponent.prototype.data;
        /** @type {?} */
        BaseDateComponent.prototype.format;
        /** @type {?} */
        BaseDateComponent.prototype.formatTip;
        /**
         * @type {?}
         * @protected
         */
        BaseDateComponent.prototype.translate;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BaseChangeComponent = /** @class */ (function () {
        function BaseChangeComponent() {
            this.format = 'day';
        }
        /**
         * @return {?}
         */
        BaseChangeComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        BaseChangeComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-change',
                        template: "<!--<base-date [data]=\"data?.date\"></base-date>-->\n<base-date\n        [data]=\"data?.date\"\n        [format]=\"format\"\n        formatTip=\"false\" [matTooltip]=\"data?.user\">\n</base-date>\n"
                    }] }
        ];
        /** @nocollapse */
        BaseChangeComponent.ctorParameters = function () { return []; };
        BaseChangeComponent.propDecorators = {
            data: [{ type: core.Input }],
            format: [{ type: core.Input }]
        };
        return BaseChangeComponent;
    }());
    if (false) {
        /** @type {?} */
        BaseChangeComponent.prototype.data;
        /** @type {?} */
        BaseChangeComponent.prototype.format;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TableSearchComponent = /** @class */ (function () {
        function TableSearchComponent(fb) {
            this.fb = fb;
            this.changed = new core.EventEmitter();
            this.debounceTime = 700;
            this.suffix = '*';
        }
        /**
         * @return {?}
         */
        TableSearchComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.formGroup = this.fb.group({
                keyword: [null, null]
            });
            this.formGroup.valueChanges.pipe(operators.distinctUntilChanged(), operators.debounceTime(this.debounceTime)).subscribe((/**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                if (!(val.keyword === null)) {
                    val.keyword = val.keyword + _this.suffix;
                }
                _this.changed.emit(val);
            }));
        };
        TableSearchComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'table-search',
                        template: "<form [formGroup]=\"formGroup\">\n  <mat-form-field>\n    <mat-label>Suchen</mat-label>\n    <input matInput formControlName=\"keyword\" type=\"search\" nullValue/>\n  </mat-form-field>\n</form>\n"
                    }] }
        ];
        /** @nocollapse */
        TableSearchComponent.ctorParameters = function () { return [
            { type: forms.FormBuilder }
        ]; };
        TableSearchComponent.propDecorators = {
            changed: [{ type: core.Output }]
        };
        return TableSearchComponent;
    }());
    if (false) {
        /** @type {?} */
        TableSearchComponent.prototype.changed;
        /** @type {?} */
        TableSearchComponent.prototype.formGroup;
        /** @type {?} */
        TableSearchComponent.prototype.debounceTime;
        /** @type {?} */
        TableSearchComponent.prototype.suffix;
        /**
         * @type {?}
         * @private
         */
        TableSearchComponent.prototype.fb;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ObjectNotFoundDialogComponent = /** @class */ (function (_super) {
        __extends(ObjectNotFoundDialogComponent, _super);
        function ObjectNotFoundDialogComponent(dialogRef, data) {
            var _this = _super.call(this, dialogRef, data) || this;
            _this.dialogRef = dialogRef;
            _this.data = data;
            return _this;
        }
        /**
         * @return {?}
         */
        ObjectNotFoundDialogComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @param {?} dialog
         * @param {?} e
         * @param {?=} opts
         * @return {?}
         */
        ObjectNotFoundDialogComponent.openObjectNotFoundDialog = /**
         * @param {?} dialog
         * @param {?} e
         * @param {?=} opts
         * @return {?}
         */
        function (dialog, e, opts) {
            if (opts === void 0) { opts = {}; }
            /** @type {?} */
            var config = Object.assign({
                canBeClosed: true,
                closeOnNavigation: true,
                panelClass: 'dialog-layout',
                disableClose: false,
            }, opts);
            config.data = ObjectNotFoundDialogComponent.extractErrorInfo(e, config.data);
            console.log('openErrorDialog: ', config);
            /** @type {?} */
            var dialogRef = dialog.open(ObjectNotFoundDialogComponent, config);
            dialogRef.disableClose = false;
            return dialogRef;
        };
        ObjectNotFoundDialogComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'app-object-not-found-dialog',
                        template: "<h2>OBJECT NOT FOUND</h2>\n<p>{{data.message}}</p>\n<mat-dialog-content>\n\n  <div class=\"error-info\">\n    <table class=\"info-grid\">\n      <tbody>\n      <tr *ngIf=\"data.status\"><td class=\"label\">Status</td><td class=\"val\">{{data.status}}</td></tr>\n      <tr *ngIf=\"data.code\"><td class=\"label\">Code</td><td class=\"val\">{{data.code}}</td></tr>\n      <tr *ngIf=\"data.link\"><td class=\"label\">Link</td><td class=\"val\">{{data.link}}</td></tr>\n      <tr *ngIf=\"data.request\"><td class=\"label\">Request</td><td class=\"val\">{{data.request}}</td></tr>\n      <tr *ngIf=\"data.operation\"><td class=\"label\">Operation</td><td class=\"val\">{{data.operation}}</td></tr>\n      <tr *ngIf=\"data.component\"><td class=\"label\">Component</td><td class=\"val\">{{data.component}}</td></tr>\n      <tr *ngIf=\"data.developerMessage\"><td class=\"label\">Dev Message:</td><td class=\"val\">{{data.developerMessage}}</td></tr>\n      </tbody>\n    </table>\n  </div>\n\n</mat-dialog-content>\n\n<mat-dialog-actions>\n  <button mat-raised-button type=\"button\" color=\"accent\" [mat-dialog-close]=\"true\">{{ 'CMD.delete' | translate }}</button>\n  <button mat-button type=\"button\" [mat-dialog-close]=\"false\">{{ 'CMD.cancel' | translate }}</button>\n</mat-dialog-actions>\n"
                    }] }
        ];
        /** @nocollapse */
        ObjectNotFoundDialogComponent.ctorParameters = function () { return [
            { type: dialog.MatDialogRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
        ]; };
        return ObjectNotFoundDialogComponent;
    }(ErrorDialog));
    if (false) {
        /** @type {?} */
        ObjectNotFoundDialogComponent.prototype.dialogRef;
        /** @type {?} */
        ObjectNotFoundDialogComponent.prototype.data;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchFieldComponent = /** @class */ (function () {
        function SearchFieldComponent() {
        }
        /**
         * @return {?}
         */
        SearchFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.searchElem) {
                rxjs.fromEvent(this.searchElem.nativeElement, 'keyup')
                    .pipe(operators.debounceTime(this.debounceTime), operators.distinctUntilChanged())
                    .subscribe((/**
                 * @param {?} event
                 * @return {?}
                 */
                function (event) {
                    /** @type {?} */
                    var value = _this.searchElem.nativeElement.value;
                    if (value == '')
                        value = null;
                    // let filter = this.dataSource.filterSubject.value;
                    // let filter = this.filter;
                    // filter.keyword = value
                    // this.reload();
                    console.log("SearchFieldComponent keyup", value);
                }));
            }
        };
        /**
         * @param {?} ev
         * @return {?}
         */
        SearchFieldComponent.prototype.onSearch = /**
         * @param {?} ev
         * @return {?}
         */
        function (ev) {
            console.log("SearchFieldComponent onSearch", ev);
        };
        SearchFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'base-search-field',
                        template: "<div class=\"field-wrap\">\n    <div class=\"field-box trans-icon\">\n        <input #searchField type=\"text\"/>\n        <button (click)=\"onSearch($event)\" type=\"button\">\n            <i><mat-icon>search</mat-icon></i>\n        </button>\n    </div>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        SearchFieldComponent.ctorParameters = function () { return []; };
        SearchFieldComponent.propDecorators = {
            searchElem: [{ type: core.ViewChild, args: ['searchField', { static: true },] }],
            debounceTime: [{ type: core.Input }]
        };
        return SearchFieldComponent;
    }());
    if (false) {
        /** @type {?} */
        SearchFieldComponent.prototype.searchElem;
        /** @type {?} */
        SearchFieldComponent.prototype.debounceTime;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChainBaseComp = /** @class */ (function () {
        function ChainBaseComp() {
        }
        ChainBaseComp.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            ErrorDialog,
                            ObjectNotFoundDialogComponent,
                            TableSearchComponent,
                            BaseChangeComponent,
                            BaseDateComponent,
                            SearchFieldComponent
                        ],
                        imports: [
                            forms.ReactiveFormsModule,
                            formField.MatFormFieldModule,
                            tooltip.MatTooltipModule,
                            icon.MatIconModule,
                            common.CommonModule,
                            dialog.MatDialogModule,
                            core$1.TranslateModule
                        ],
                        exports: [
                            ErrorDialog,
                            ObjectNotFoundDialogComponent,
                            TableSearchComponent,
                            BaseChangeComponent,
                            BaseDateComponent
                        ],
                        entryComponents: [
                            ObjectNotFoundDialogComponent,
                            //ValidationResultDialogComponent,
                            ErrorDialog
                        ],
                        schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                    },] }
        ];
        return ChainBaseComp;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TYPE_INVOICE = "INVOICE";
    /**
     * @deprecated
     */
    var   /**
     * @deprecated
     */
    AddressUtils = /** @class */ (function () {
        //public static readonly TYPE_INVOICE = "INVOICE";
        function AddressUtils() {
        }
        /**
         * @param {?} address
         * @param {?} type
         * @return {?}
         */
        AddressUtils.findAddressByType = /**
         * @param {?} address
         * @param {?} type
         * @return {?}
         */
        function (address, type) {
            console.log("AddressUtils.findAddressByType");
            console.log("AddressUtils.findAddressByType", address);
            console.log("AddressUtils.findAddressByType", type);
            return address.filter((/**
             * @param {?} val
             * @return {?}
             */
            function (val) { return val.type != null; })).find((/**
             * @param {?} val
             * @return {?}
             */
            function (val) { return val.type === TYPE_INVOICE; }));
            // return address.filter(val => val.type ==true).find(value => value.type == TYPE_INVOICE);
            //  return null;
            // throw new Error("fubar ts")
        };
        /**
         * @param {?} fb
         * @param {?=} initial
         * @param {?=} validators
         * @return {?}
         */
        AddressUtils.getFormGroup = /**
         * @param {?} fb
         * @param {?=} initial
         * @param {?=} validators
         * @return {?}
         */
        function (fb, initial, validators) {
            /** @type {?} */
            var group = fb.group({
                type: [null, null],
                street: [null, null],
                houseNumber: [null, null],
                countryCode: [null, null],
                city: [null, null],
                zipCode: [null, null],
                desc: [null, null]
            });
            if (initial) {
                group.patchValue(initial);
            }
            return group;
        };
        /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        AddressUtils.addAddressToFormArray = /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        function (fa, fb, initial) {
            /** @type {?} */
            var formArray = (/** @type {?} */ (fa));
            formArray.push(this.getFormGroup(fb, initial));
        };
        /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        AddressUtils.addAndGetAddress = /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        function (fa, fb, initial) {
            /** @type {?} */
            var formArray = (/** @type {?} */ (fa));
            /** @type {?} */
            var group = this.getFormGroup(fb, initial);
            formArray.push(group);
            return group;
        };
        return AddressUtils;
    }());

    exports.AddressUtils = AddressUtils;
    exports.BaseChangeComponent = BaseChangeComponent;
    exports.BaseDateComponent = BaseDateComponent;
    exports.ChainBaseComp = ChainBaseComp;
    exports.ErrorDialog = ErrorDialog;
    exports.ErrorDialogHandler = ErrorDialogHandler;
    exports.ObjectNotFoundDialogComponent = ObjectNotFoundDialogComponent;
    exports.TableSearchComponent = TableSearchComponent;
    exports.ɵa = SearchFieldComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-base-angular-comp.umd.js.map
